#!/bin/bash

exptName=$1
foldername='data-'$exptName
#filename='brake2_2_po.c'

if [ -d $foldername ]
then
  echo "Folder " + $foldername+ " already exists. "
  exit
fi
 
mkdir $foldername

BENCHMARKS=
PWD=`pwd`
PROGRESSLOG=${PWD}/${foldername}/progress.log
TIMELOG=${PWD}/${foldername}/runtime.log

#EXEC=~/i-cbmc/src-r4781/cbmc/cbmc
#EXEC=~/diffblue/cbmc-master/src/cbmc/cbmc
#FLAGS="-DCBMC -DREAL_T=float -DUSE_FLOAT"

EXEC=~/conc-tools/impara-0.5/impara
FLAGS="--eager -DCBMC -DREAL_T=float -DUSE_FLOAT"

RUNSOLVER=~/runsolver/src/runsolver
CTIMEOUT=3600
WTIMEOUT=7200
MEM=16384
SUFFIX=""

echo "Starting experiments at `date` on `hostname`" > ${PROGRESSLOG}${SUFFIX}
                                                         
#for filename  in `ls ${BENCHMARKS}/*.c`;
for filename in `ls brake2_*_conc_cprover.c`
do
rm -f ${foldername}/${filename}.watch${SUFFIX}
rm -f ${foldername}/${filename}.out${SUFFIX}
rm -f ${foldername}/${filename}.time${SUFFIX}
echo -n "Starting to processing  $filename at `date`" >> ${PROGRESSLOG}${SUFFIX}
${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} ${FLAGS} $filename
grep -e "CPUTIME=" ${foldername}/${filename}.time${SUFFIX} >> ${PROGRESSLOG}${SUFFIX}
done
