#!/bin/bash

exptName=$1
codefolder=$2
#fileName=$2
foldername=${codefolder}/data-$exptName

if [ -d $foldername ]
then
  echo "Folder " + $foldername + " already exists. "
  exit
fi
 
mkdir $foldername

#PWD=`pwd`
PROGRESSLOG=${foldername}/progress.log
TIMELOG=${foldername}/runtime.log

#EXEC=~/diffblue/cbmc-master/src/cbmc/cbmc
#FLAGS="--unwind 3 --no-unwinding-assertions --error-label ERROR"

#EXEC=./lazy-cseq-abs.py
#EXEC=./lazy-cseq-swarm.py
EXEC=./lazy-cseq.py
FLAGS="--spec ./ALL.prp"

#EXEC=~/seq-tools/CPAchecker-1.6.12-svcomp17-unix/scripts/cpa.sh
#FLAGS="-timelimit 900 -sv-comp17 -preprocess -disable-java-assertions -heap 10000m -spec ALL.prp -setprop cpa.callstack.skipVoidRecursion=false"
#FLAGS="-sv-comp17 -disable-java-assertions -heap 10000m -spec config/specification/ErrorLabel.spcp -setprop cpa.callstack.skipVoidRecursion=false"

#EXEC=~/seq-tools/blast-2.7.3/bin/pblast.opt
#FLAGS="-alias empty -enable-recursion -noprofile -cref -sv-comp -lattice -include-lattice symb -nosserr -propertyfile ALL.prp"

RUNSOLVER=~/runsolver/src/runsolver
CTIMEOUT=3600
WTIMEOUT=7200
MEM=16384
SUFFIX=""

echo "Starting experiments at `date` on `hostname`" > ${PROGRESSLOG}${SUFFIX}
                                                         
#for benchmark in `ls $codefolder/brake2_*_conc.c` # for the Brake benchmark
for benchmark in `ls $codefolder/*.c` # use *.i for BLAST
do
filename=`basename $benchmark`

rm -f ${foldername}/${filename}.watch${SUFFIX}
rm -f ${foldername}/${filename}.out${SUFFIX}
rm -f ${foldername}/${filename}.time${SUFFIX}

errfile=${foldername}/${filename}'_blast.error' # BLAST

echo -n "Starting to processing  ${filename} at `date`" >> ${PROGRESSLOG}${SUFFIX}

#${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} ${FLAGS} $benchmark

# CSeq
${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} --input $benchmark ${FLAGS} --witness ${foldername}/${filename}.witness

# BLAST
#${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} ${FLAGS}  -errorpathfile $errfile $benchmark

grep -e "CPUTIME=" ${foldername}/${filename}.time${SUFFIX} >> ${PROGRESSLOG}${SUFFIX}
done
