#!/bin/bash

exptName=$1
#fileName=$2
foldername='data-'$exptName

if [ -d $foldername ]
then
  echo "Folder " + $foldername+ " already exists. "
  exit
fi
 
mkdir $foldername

PWD=`pwd`
PROGRESSLOG=${PWD}/${foldername}/progress.log
TIMELOG=${PWD}/${foldername}/runtime.log

#EXEC=~/diffblue/cbmc-master/src/cbmc/cbmc
#FLAGS="--unwind 3 --no-unwinding-assertions --error-label ERROR"

#EXEC=~/conc-tools/esbmc-v4.1.0-linux-static-64/bin/esbmc
#FLAGS="--64 --timeout 3600s --memlimit 15g --no-div-by-zero-check --force-malloc-success --context-bound 7 --floatbv --witness-output witness.graphml --k-induction --unlimited-k-steps --clang-frontend --no-pointer-check --no-bounds-check --error-label ERROR"
#FLAGS="--64 --timeout 3600s --memlimit 15g --no-div-by-zero-check --force-malloc-success --context-bound 7 --floatbv --witness-output witness.graphml --incremental-bmc --unlimited-k-steps --clang-frontend --no-pointer-check --no-bounds-check --error-label ERROR"

EXEC=~/conc-tools/esbmc-v4.4.0-linux-static-64/bin/esbmc
FLAGS="--64 --timeout 3600s --memlimit 15g --no-div-by-zero-check --force-malloc-success --floatbv --witness-output witness.graphml --incremental-bmc --unlimited-k-steps --no-pointer-check --no-bounds-check --no-bitfields --error-label ERROR"
#FLAGS="--64 --timeout 3600s --memlimit 15g --no-div-by-zero-check --force-malloc-success --floatbv --witness-output witness.graphml --k-induction --unlimited-k-steps --no-pointer-check --no-bounds-check --no-bitfields --error-label ERROR"

#EXEC=~/conc-tools/esbmc-svcomp17/esbmc-wrapper.py
#EXEC=~/conc-tools/esbmc-v4.1.0-linux-static-64/bin/esbmc-wrapper.py
#FLAGS="-a 64 -p ALL.prp -s kinduction"
#FLAGS="-a 64 -p ALL.prp -s incr"

#EXEC=~/seq-tools/CPAchecker-1.6.12-svcomp17-unix/scripts/cpa.sh
#FLAGS="-sv-comp17 -disable-java-assertions -heap 10000m -spec config/specification/ErrorLabel.spcp -setprop cpa.callstack.skipVoidRecursion=false"

RUNSOLVER=~/runsolver/src/runsolver
CTIMEOUT=3600
WTIMEOUT=7200
MEM=16384
SUFFIX=""

echo "Starting experiments at `date` on `hostname`" > ${PROGRESSLOG}${SUFFIX}
                                                         
for filename in `ls *.c`
do
rm -f ${foldername}/${filename}.watch${SUFFIX}
rm -f ${foldername}/${filename}.out${SUFFIX}
rm -f ${foldername}/${filename}.time${SUFFIX}
echo -n "Starting to processing  $filename at `date`" >> ${PROGRESSLOG}${SUFFIX}
${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} ${FLAGS} $filename
grep -e "CPUTIME=" ${foldername}/${filename}.time${SUFFIX} >> ${PROGRESSLOG}${SUFFIX}
done
