#!/bin/bash

exptName=$1
#fileName=$2
foldername='data-'$exptName

if [ -d $foldername ]
then
  echo "Folder " + $foldername+ " already exists. "
  exit
fi
 
mkdir $foldername

PWD=`pwd`
PROGRESSLOG=${PWD}/${foldername}/progress.log
TIMELOG=${PWD}/${foldername}/runtime.log

#EXEC=~/diffblue/cbmc-master/src/cbmc/cbmc
#FLAGS="--unwind 2 --no-unwinding-assertions --error-label ERROR -DCBMC"

#EXEC=~/seq-tools/CPAchecker-1.6.12-svcomp17-unix/scripts/cpa.sh
#FLAGS="-sv-comp17 -disable-java-assertions -heap 10000m -spec ALL.prp -setprop cpa.callstack.skipVoidRecursion=false"
#FLAGS="-sv-comp17 -disable-java-assertions -heap 10000m -spec config/specification/ErrorLabel.spcp -setprop cpa.callstack.skipVoidRecursion=false"

EXEC=~/seq-tools/blast-2.7.3/bin/pblast.opt
FLAGS="-alias empty -enable-recursion -noprofile -cref -sv-comp -lattice -include-lattice symb -nosserr -propertyfile ALL.prp"

RUNSOLVER=~/runsolver/src/runsolver
CTIMEOUT=3600
WTIMEOUT=7200
MEM=16384
SUFFIX=""

echo "Starting experiments at `date` on `hostname`" > ${PROGRESSLOG}${SUFFIX}
                                                        
#for filename in `ls brake2_*_por_seq.c`
for filename in `ls brake2_*_por_seq.i` # .i for BLAST
do
rm -f ${foldername}/${filename}.watch${SUFFIX}
rm -f ${foldername}/${filename}.out${SUFFIX}
rm -f ${foldername}/${filename}.time${SUFFIX}

errfile=${foldername}/${filename}_blast.error # BLAST

echo -n "Starting to processing  $filename at `date`" >> ${PROGRESSLOG}${SUFFIX}

#${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} ${FLAGS} $filename

# BLAST
${RUNSOLVER} -w ${foldername}/${filename}.watch${SUFFIX} -v ${foldername}/${filename}.time${SUFFIX} -o ${foldername}/${filename}.out${SUFFIX} -C ${CTIMEOUT} -W ${WTIMEOUT} -d 1 -M ${MEM} ${EXEC} ${FLAGS}  -errorpathfile $errfile $filename

grep -e "CPUTIME=" ${foldername}/${filename}.time${SUFFIX} >> ${PROGRESSLOG}${SUFFIX}
done
